VERSION 5.00
Begin VB.Form frmAddIn 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "My Add In"
   ClientHeight    =   3195
   ClientLeft      =   2175
   ClientTop       =   1935
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmAddIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public VBInstance As VBIDE.VBE
Public Connect As Connect

Const CurrentModule As String = "frmAddIn"

Private Sub HandleError(ByVal CurrentModule As String, ByVal CurrentProcedure As String, ByVal ErrNum As Long, ByVal ErrDescription As String)
    On Error GoTo Err_Init
    MsgBox CurrentModule & " " & CurrentProcedure & ": " & ErrNum & " - " & ErrDescription
    Exit Sub
Err_Init:
    MsgBox CurrentModule & " HandleError: " & Err.Number & " - " & Err.Description
End Sub

Private Sub CancelButton_Click()
    Connect.Hide
End Sub

Private Sub OKButton_Click()
    Dim s As String
    CurrentProc
End Sub

Friend Function CurrentProc()
    Dim oCodePane As CodePane
    Dim oCodeMod As CodeModule
    Dim iCurrentLine As Long, b As Long, c As Long, d As Long, StartLine As Long, EndLine As Long
    Dim sProcName As String, FindIt As Boolean
    Dim eProcKind As vbext_ProcKind
    Dim ExitStatement As String
 
    Set oCodePane = VBInstance.ActiveCodePane
    If oCodePane Is Nothing Then
        'they're not in the code pane.
        MsgBox "You must be sitting on a procedure to add error handling!"
        Exit Function
    End If
    Set oCodeMod = oCodePane.CodeModule
    'returns the current line that cursor is on
    oCodePane.GetSelection iCurrentLine, b, c, d
    'returns the procedure name and the ProcKind (procedure, property get, etc)
    sProcName = oCodeMod.ProcOfLine(iCurrentLine, eProcKind)
    If sProcName = "" Then
        'They're sitting in the declarations section.
        '---
        'Look for 'option explicit'
        StartLine = 1
        EndLine = oCodeMod.CountOfLines
        FindIt = oCodeMod.Find("Option Explicit", StartLine, 1, EndLine, -1, True, False, False)
        If FindIt = True Then
            'MsgBox "This routine already has option explicit!"
        Else
            'Insert Option Explicit
            oCodeMod.InsertLines 1, "Option Explicit"
        End If
        '---
        'Look for module level constant used by error handler.
        StartLine = 1
        EndLine = oCodeMod.CountOfLines
        FindIt = oCodeMod.Find("Const CurrentModule as string", StartLine, 1, EndLine, -1, True, False, False)
        If FindIt = True Then
            'MsgBox "This routine already has const CurrentModule as string!"
        Else
            'Insert Current Module
            oCodeMod.InsertLines 2, "Const CurrentModule As String = " & """" & oCodeMod.Parent.Name & """"
        End If
    Else
        'they're sitting in a routine.
        '---
        'Add "on error goto err_init"
        StartLine = oCodeMod.ProcStartLine(sProcName, eProcKind)
        EndLine = oCodeMod.ProcCountLines(sProcName, eProcKind) + StartLine
        FindIt = oCodeMod.Find("On Error Goto Err_Init", StartLine, 1, EndLine, -1, True, False, False)
        If FindIt = True Then
            'MsgBox "This routine already contains error handling!"
            Exit Function
        End If
        CurrentProc = sProcName
        StartLine = oCodeMod.ProcBodyLine(sProcName, eProcKind)
        'Find the next statement past the first one
        Do While InStr(1, oCodeMod.Lines(StartLine, 1), " _", vbTextCompare) > 0
            StartLine = StartLine + 1
        Loop
        oCodeMod.InsertLines StartLine + 1, vbTab & "On Error Goto Err_Init"
        '---
        'Add "Err_Init: err handler"
        StartLine = oCodeMod.ProcStartLine(sProcName, eProcKind)
        EndLine = oCodeMod.ProcCountLines(sProcName, eProcKind) + StartLine
        FindIt = oCodeMod.Find("Err_Init:", StartLine, 1, EndLine, -1, True, False, False)
        If FindIt = True Then
            'MsgBox "This routine already contains error handling!"
            Exit Function
        End If
        If eProcKind = vbext_pk_Proc Then
            'method or function
            FindIt = oCodeMod.Find("Function ", StartLine, 1, EndLine, -1, False, False, False)
            If FindIt = True Then
                ExitStatement = vbTab & "Exit Function"
            Else
                ExitStatement = vbTab & "Exit Sub"
            End If
        Else
            ExitStatement = vbTab & "Exit Property"
        End If
        CurrentProc = sProcName
        'Find the last statement
        StartLine = oCodeMod.ProcStartLine(sProcName, eProcKind)
        StartLine = StartLine + oCodeMod.ProcCountLines(sProcName, eProcKind)
        Do While StrComp(oCodeMod.Lines(StartLine, 1), "", vbTextCompare) = 0
            StartLine = StartLine - 1
        Loop
        'Insert the line
        oCodeMod.InsertLines StartLine, ExitStatement & vbCrLf & vbCrLf & vbTab & "Err_Init:" & vbCrLf & vbTab & "HandleError CurrentModule, " & """" & CurrentProc & """" & ",Err.Number,Err.Description"
    End If
End Function

